import { csvParse, select } from 'd3';

export const viz = (
  container,
  { state, setState }
) => {
  
  select(container)
    .selectAll('pre')
    .data([null])
    .join('pre')
    .text(JSON.stringify(state.data, null, 2));
 
  // state.data could be:
  // * undefined
  // * 'LOADING'
  // * An array of objects
  const { data } = state;

  if (data === undefined) {
    setState((state) => ({
      ...state,
      data: 'LOADING',
    }));
    fetch('data.csv')
      .then((response) => response.text())
      .then((csvString) => {
        const data = csvParse(csvString);
      
        for (const d of data) {
          d.Watch_time_minutes = +d.Watch_time_minutes;
          d.Stream_time_minutes = +d.Stream_time_minutes;
          d.Peak_viewers = +d.Peak_viewers;
          d.Average_viewers = +d.Average_viewers;
          d.Followers = +d.Followers;
          d.Followers_gained = +d.Followers_gained;
          d.Views_gained = +d.Views_gained;
        }
      
        setState((state) => ({
          ...state,
          data,
        }));
      });
  }
};
